% Leggo i dati da file
data = dlmread('ch13_es4.csv');
% Separo le x e le y
x0 = data(:, 1);
y0 = data(:, 2);
% Estremi dell'intervallo
x_l = 1;
x_u = 5;

function phi = build_phi_matrix(x)
	phi = [x.^2, x.^1, x.^0];
end

function z = eval_f(p, x)
	z = p(1) .* x.^2 + p(2) .* x + p(3);
end

function z = eval_fp(p, x)
	z = p(1) .* 2 .* x + p(2);
end

function plot_approx(p, x_l, x_u, x0, y0)
	% "p" sono i parametri della funzione approssimante
	% "x_l" e "x_u" sono gli estremi dell'intervallo da disegnare
	% "x" e "y" sono i punti campionati

	% Definisco il range per il disegno
	x = linspace(x_l, x_u);
	% Ottengo i valori della funzione approssimante
	y = eval_f(p, x);

	% Disegno il polinomio interpolante
	figure() % Apro una nuova figura
	hold on % Permetto di avere più di un plot sulla figura
	plot(x, y, 'k', 'linewidth', 1.5);
	% Disegno i punti originari
	scatter(x0, y0, 4, 'r', 'x');
	hold off
	xlim([x_l, x_u]);
end

% Ottengo la funzione approssimante
phi = build_phi_matrix(x0);
p = phi \ y0
plot_approx(p, x_l, x_u, x0, y0)

% Ottengo la derivata nel punto richiesto
d = eval_fp(p, 2)